<template>
  <div class="box p-5 md:p-8 mb-10">
    <form @submit.prevent="form.patch(`/roster/shift/${shift.id}`, { preserveScroll: true })" autocomplete="off">
      <h3>Edit Department Shift</h3>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full">
              <label for="department-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                Shift Name</label>
              <input id="name" class="input w-full" type="text" placeholder="Enter department name"
                v-model="form.name" />
              <div v-if="form.errors.name" class="text-error">
                {{ form.errors.name }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full md:w-1/2 mr-2">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                Start Time</label>
              <input id="start-time" class="input w-full" type="time" v-model="form.start_time" />
              <div v-if="form.errors.start_time" class="text-error">
                {{ form.errors.start_time }}
              </div>
            </div>
            <div class="flex flex-col w-full md:w-1/2">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                End Time</label>
              <input id="end-time" class="input w-full" type="time" v-model="form.end_time" />
              <div v-if="form.errors.end_time" class="text-error">
                {{ form.errors.end_time }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700 ">
          Color</label>
        <input type="color" v-model="form.color" />
        <div v-if="form.errors.color" class="text-error">
          {{ form.errors.color }}
        </div>
      </div>

      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700 ">
          Department</label>
        <multiselect v-model="form.department" :multiple="false" :options="departments" label="name" track-by="id"
          :customLabel="(department) => `${department.name}`">
        </multiselect>
        <div v-if="form.errors.department" class="text-error">
          {{ form.errors.department }}
        </div>
      </div>

      <div class="flex gap-x-3 mt-3 flex-row-reverse">
        <button class="btn green"> Save</button>
        <Link as="button" href="/roster/shift" class="btn orange">
          Cancel
        </Link>
      </div>
    </form>
  </div>
</template>

<script setup>
import { Link, useForm } from '@inertiajs/vue3';

const props = defineProps({
  departments: Array,
  shift: Object
})

const form = useForm({
  name: props.shift.name,
  start_time: props.shift.start_time.slice(0, -3),
  end_time: props.shift.end_time.slice(0, -3),
  department: props.shift.department,
  color: props.shift.color
});

</script>